
Public Class ScanImage
    Private WiaClass As WIALib.WiaClass
    Private ItemClass As WIALib.ItemClass
    Private CollectionClassDevices As WIALib.CollectionClass
    Private CollectionClassPics As WIALib.CollectionClass

    Private selectUsingUI As Object

#Region "SelectDevice"
    Public Function SelectDevice() As Boolean
        Try
            WiaClass = New WIALib.WiaClass()
            CollectionClassDevices = DirectCast(WiaClass.Devices, WIALib.CollectionClass)

            If WiaClass.Devices.Count = 0 Then
                Return False
            End If

            selectUsingUI = System.Reflection.Missing.Value

            ItemClass = DirectCast(WiaClass.Create(selectUsingUI), WIALib.ItemClass)

            If ItemClass Is Nothing Then
                Return False
            End If

            Return True
        Catch exp As System.Exception
            Return False
        End Try
        Return False
    End Function
#End Region

#Region "DeviceSetting"
    Public Function DeviceSetting() As Boolean
        Try
            CollectionClassPics = DirectCast(ItemClass.GetItemsFromUI(WIALib.WiaFlag.SingleImage, WIALib.WiaIntent.MaximizeQuality), WIALib.CollectionClass)
            If CollectionClassPics Is Nothing Then
                Return False
            End If
        Catch exp As System.Exception
            Return False
        End Try
        Return True
    End Function
#End Region

#Region "Capture"
    Public Function Capture() As System.Drawing.Image
        Try
            If CollectionClassPics(0) IsNot Nothing Then
                Dim Image As System.Drawing.Image
                Dim ItemClassCurrent As WIALib.ItemClass = DirectCast(System.Runtime.InteropServices.Marshal.CreateWrapperOfType(CollectionClassPics(0), GetType(WIALib.ItemClass)), WIALib.ItemClass)

                Dim fileName As String = System.IO.Path.GetTempFileName()
                ItemClassCurrent.Transfer(fileName, False)

                Image = System.Drawing.Image.FromFile(fileName)

                System.Runtime.InteropServices.Marshal.ReleaseComObject(CollectionClassPics(0))

                Return Image
            End If

            Return Nothing
        Catch exp As System.Exception
            Return Nothing
        End Try
    End Function
#End Region
End Class
